/*
 * Author: Dušan Kolář
 */

#include "dlms_data.h"

// .................................................................
// .................................................................

int test_dlms_data_type(uint8_t dlms_data_type) {
    switch (dlms_data_type) {
        case DLMS_NULL_DATA:
        case DLMS_ARRAY:
        case DLMS_STRUCTURE:
        case DLMS_BOOLEAN:
        case DLMS_BIT_STRING:
        case DLMS_DOUBLE_LONG:
        case DLMS_U_DOUBLE_LONG:
        case DLMS_OCTET_STRING:
        case DLMS_VISIBLE_STRING:
        case DLMS_BCD:
        case DLMS_INTEGER:
        case DLMS_LONG:
        case DLMS_UNSIGNED:
        case DLMS_U_LONG:
        case DLMS_COMPACT_ARRAY:
        case DLMS_LONG64:
        case DLMS_U_LONG64:
        case DLMS_ENUM:
        case DLMS_FLOAT32:
        case DLMS_FLOAT64:
        case DLMS_DATE_TIME:
        case DLMS_DATE:
        case DLMS_TIME:
        case DLMS_DO_NOT_CARE:
            return ((int)dlms_data_type);
        default:
            return (-1);
    }
}

// .................................................................

const char *text_dlms_data_type(uint8_t dlms_data_type) {
    switch (dlms_data_type) {
        case DLMS_NULL_DATA:
            return ("NULL_DATA");
        case DLMS_ARRAY:
            return ("ARRAY");
        case DLMS_STRUCTURE:
            return ("STRUCTURE");
        case DLMS_BOOLEAN:
            return ("BOOLEAN");
        case DLMS_BIT_STRING:
            return ("BIT_STRING");
        case DLMS_DOUBLE_LONG:
            return ("DOUBLE_LONG");
        case DLMS_U_DOUBLE_LONG:
            return ("UNSIGNED_DOUBLE_LONG");
        case DLMS_OCTET_STRING:
            return ("OCTET_STRING");
        case DLMS_VISIBLE_STRING:
            return ("VISIBLE_STRING");
        case DLMS_BCD:
            return ("BCD");
        case DLMS_INTEGER:
            return ("INTEGER");
        case DLMS_LONG:
            return ("LONG");
        case DLMS_UNSIGNED:
            return ("UNSIGNED");
        case DLMS_U_LONG:
            return ("UNSIGNED_LONG");
        case DLMS_COMPACT_ARRAY:
            return ("COMPACT_ARRRAY");
        case DLMS_LONG64:
            return ("LONG64");
        case DLMS_U_LONG64:
            return ("UNSIGNED_LONG64");
        case DLMS_ENUM:
            return ("ENUM");
        case DLMS_FLOAT32:
            return ("FLOAT32");
        case DLMS_FLOAT64:
            return ("FLOAT64");
        case DLMS_DATE_TIME:
            return ("DATE_TIME");
        case DLMS_DATE:
            return ("DATE");
        case DLMS_TIME:
            return ("TIME");
        case DLMS_DO_NOT_CARE:
            return ("DO_NOT_CARE");
        default:
            return ("");
    }
}

// EOF dlms_data
// .................................................................
// .................................................................
