/*
 * Author: Dušan Kolář
 */

#include "vlq_base128_be.h"

uint64_t readSeq(uint8_t **sequence, uint32_t *seq_length, int *error) {
    uint8_t *ptr = *sequence;
    uint64_t res = 0;
    unsigned ctr = 0;
    while (*seq_length > 0) {
        res <<= 7;
        uint8_t val = *(ptr++);
        res += (uint64_t)((val & 0xFE) >> 1);
        if (val & 0x01) break;
        if (++ctr > 8) {
            *error = VLQ_ERR_INPUT_TOO_LONG;
            return (res);
        }
        --(*seq_length);
    }
    if (*seq_length == 0) {
        *error = VLQ_ERR_EOS_REACHED;
        return (res);
    }
    --(*seq_length);
    *sequence = ptr;
    *error    = VLQ_ERR_OK;
    return (res);
}
